<?php


namespace Drupal\entity_reference_hierarchy_paragraphs\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\entity_reference_hierarchy\Plugin\Field\FieldWidget\EntityReferenceHierarchyWidgetTrait;
use Drupal\paragraphs\Plugin\Field\FieldWidget\InlineParagraphsWidget;

/**
 * Plugin implementation of the 'entity_reference_hierarchy_autocomplete' widget.
 *
 * @FieldWidget(
 *   id = "entity_reference_hierarchy_paragraphs",
 *   label = @Translation("Paragraphs Classic"),
 *   description = @Translation("A paragraphs inline form widget."),
 *   field_types = {
 *     "entity_reference_hierarchy_revisions"
 *   }
 * )
 */
class InlineParagraphsHierarchyWidget extends InlineParagraphsWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

    $element['depth'] = [
      '#type' => 'textfield',
      '#size' => 3,
      '#title' => $this->t('Depth for row @number', ['@number' => $delta + 1]),
      '#title_display' => 'invisible',
      '#default_value' => !empty($items[$delta]->depth) ? $items[$delta]->depth : 0,
    ];

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function formMultipleElements(FieldItemListInterface $items, array &$form, FormStateInterface $form_state) {
    $elements = parent::formMultipleElements($items, $form, $form_state);

    $elements['#entity_reference_hierarchy_paragraphs'] = TRUE;

    return $elements;
  }

}
