<?php


namespace Drupal\entity_reference_hierarchy\Plugin\Field\FieldWidget;


use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class EntityReferenceHierarchyWidgetTrait
 */
trait EntityReferenceHierarchyWidgetTrait {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

    $element['depth'] = [
      '#type' => 'textfield',
      '#size' => 3,
      '#title' => $this->t('Depth for row @number', ['@number' => $delta + 1]),
      '#title_display' => 'invisible',
      '#default_value' => !empty($items[$delta]->depth) ? $items[$delta]->depth : 0,
    ];

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function formMultipleElements(FieldItemListInterface $items, array &$form, FormStateInterface $form_state) {
    $elements = parent::formMultipleElements($items, $form, $form_state);

    $elements['#entity_reference_hierarchy'] = TRUE;

    return $elements;
  }

}
